Merge "Enable internal network TLS for etcd"
[apex-tripleo-heat-templates.git] / extraconfig / tasks / yum_update.sh
1 #!/bin/bash
2
3 # A heat-config-script which runs yum update during a stack-update.
4 # Inputs:
5 #   deploy_action - yum will only be run if this is UPDATE
6 #   update_identifier - yum will only run for previously unused values of update_identifier
7 #   command - yum sub-command to run, defaults to "update"
8 #   command_arguments - yum command arguments, defaults to ""
9
10 echo "Started yum_update.sh on server $deploy_server_id at `date`"
11 echo -n "false" > $heat_outputs_path.update_managed_packages
12
13 if [ -f /.dockerenv ]; then
14     echo "Not running due to running inside a container"
15     exit 0
16 fi
17
18 if [[ -z "$update_identifier" ]]; then
19     echo "Not running due to unset update_identifier"
20     exit 0
21 fi
22
23 timestamp_dir=/var/lib/overcloud-yum-update
24 mkdir -p $timestamp_dir
25
26 # sanitise to remove unusual characters
27 update_identifier=${update_identifier//[^a-zA-Z0-9-_]/}
28
29 # seconds to wait for this node to rejoin the cluster after update
30 cluster_start_timeout=600
31 galera_sync_timeout=1800
32 cluster_settle_timeout=1800
33
34 timestamp_file="$timestamp_dir/$update_identifier"
35 if [[ -a "$timestamp_file" ]]; then
36     echo "Not running for already-run timestamp \"$update_identifier\""
37     exit 0
38 fi
39 touch "$timestamp_file"
40
41 command_arguments=${command_arguments:-}
42
43 # yum check-update exits 100 if updates are available
44 set +e
45 check_update=$(yum check-update 2>&1)
46 check_update_exit=$?
47 set -e
48
49 if [[ "$check_update_exit" == "1" ]]; then
50     echo "Failed to check for package updates"
51     echo "$check_update"
52     exit 1
53 elif [[ "$check_update_exit" != "100" ]]; then
54     echo "No packages require updating"
55     exit 0
56 fi
57
58 pacemaker_status=""
59 if hiera -c /etc/puppet/hiera.yaml service_names | grep -q pacemaker; then
60     pacemaker_status=$(systemctl is-active pacemaker)
61 fi
62
63 # Fix the redis/rabbit resource start/stop timeouts. See https://bugs.launchpad.net/tripleo/+bug/1633455
64 # and https://bugs.launchpad.net/tripleo/+bug/1634851
65 if [[ "$pacemaker_status" == "active" && \
66       "$(hiera -c /etc/puppet/hiera.yaml bootstrap_nodeid)" = "$(facter hostname)" ]] ; then
67     if pcs resource show rabbitmq | grep -E "start.*timeout=100"; then
68         pcs resource update rabbitmq op start timeout=200s
69     fi
70     if pcs resource show rabbitmq | grep -E "stop.*timeout=90"; then
71         pcs resource update rabbitmq op stop timeout=200s
72     fi
73     if pcs resource show redis | grep -E "start.*timeout=120"; then
74         pcs resource update redis op start timeout=200s
75     fi
76     if pcs resource show redis | grep -E "stop.*timeout=120"; then
77         pcs resource update redis op stop timeout=200s
78     fi
79 fi
80
81 # special case https://bugs.launchpad.net/tripleo/+bug/1635205 +bug/1669714
82 special_case_ovs_upgrade_if_needed
83
84 if [[ "$pacemaker_status" == "active" ]] ; then
85     echo "Pacemaker running, stopping cluster node and doing full package update"
86     node_count=$(pcs status xml | grep -o "<nodes_configured.*/>" | grep -o 'number="[0-9]*"' | grep -o "[0-9]*")
87     if [[ "$node_count" == "1" ]] ; then
88         echo "Active node count is 1, stopping node with --force"
89         pcs cluster stop --force
90     else
91         pcs cluster stop
92     fi
93 else
94     echo "Upgrading openstack-puppet-modules and its dependencies"
95     yum -q -y update openstack-puppet-modules
96     yum deplist openstack-puppet-modules | awk '/dependency/{print $2}' | xargs yum -q -y update
97     echo "Upgrading other packages is handled by config management tooling"
98     echo -n "true" > $heat_outputs_path.update_managed_packages
99     exit 0
100 fi
101
102 command=${command:-update}
103 full_command="yum -q -y $command $command_arguments"
104 echo "Running: $full_command"
105
106 result=$($full_command)
107 return_code=$?
108 echo "$result"
109 echo "yum return code: $return_code"
110
111 if [[ "$pacemaker_status" == "active" ]] ; then
112     echo "Starting cluster node"
113     pcs cluster start
114
115     hostname=$(hostname -s)
116     tstart=$(date +%s)
117     while [[ "$(pcs status | grep "^Online" | grep -F -o $hostname)" == "" ]]; do
118         sleep 5
119         tnow=$(date +%s)
120         if (( tnow-tstart > cluster_start_timeout )) ; then
121             echo "ERROR $hostname failed to join cluster in $cluster_start_timeout seconds"
122             pcs status
123             exit 1
124         fi
125     done
126
127     RETVAL=$( pcs resource show galera-master | grep wsrep_cluster_address | grep -q `crm_node -n` ; echo $? )
128
129     if [[ $RETVAL -eq 0 && -e /etc/sysconfig/clustercheck ]]; then
130         tstart=$(date +%s)
131         while ! clustercheck; do
132             sleep 5
133             tnow=$(date +%s)
134             if (( tnow-tstart > galera_sync_timeout )) ; then
135                 echo "ERROR galera sync timed out"
136                 exit 1
137             fi
138         done
139     fi
140
141     echo "Waiting for pacemaker cluster to settle"
142     if ! timeout -k 10 $cluster_settle_timeout crm_resource --wait; then
143         echo "ERROR timed out while waiting for the cluster to settle"
144         exit 1
145     fi
146
147     pcs status
148 fi
149
150 echo "Finished yum_update.sh on server $deploy_server_id at `date`"
151
152 exit $return_code